Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ boot/Makefile.common	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -168,4 +168,5 @@
 
 RD_APPS_NON_ESSENTIAL = \
+	$(USPACE_PATH)/app/barber/barber \
 	$(USPACE_PATH)/app/bithenge/bithenge \
 	$(USPACE_PATH)/app/blkdump/blkdump \
Index: kernel/generic/src/sysinfo/stats.c
===================================================================
--- kernel/generic/src/sysinfo/stats.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ kernel/generic/src/sysinfo/stats.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -80,18 +80,4 @@
 static mutex_t load_lock;
 
-/** Get system uptime
- *
- * @param item Sysinfo item (unused).
- * @param data Unused.
- *
- * @return System uptime (in secords).
- *
- */
-static sysarg_t get_stats_uptime(struct sysinfo_item *item, void *data)
-{
-	/* This doesn't have to be very accurate */
-	return uptime->seconds1;
-}
-
 /** Get statistics of all CPUs
  *
@@ -818,5 +804,4 @@
 	mutex_initialize(&load_lock, MUTEX_PASSIVE);
 	
-	sysinfo_set_item_gen_val("system.uptime", NULL, get_stats_uptime, NULL);
 	sysinfo_set_item_gen_data("system.cpus", NULL, get_stats_cpus, NULL);
 	sysinfo_set_item_gen_data("system.physmem", NULL, get_stats_physmem, NULL);
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/Makefile	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -34,4 +34,5 @@
 
 DIRS = \
+	app/barber \
 	app/bdsh \
 	app/bithenge \
@@ -211,4 +212,5 @@
 	lib/fmtutil \
 	lib/scsi \
+	lib/compress \
 	lib/softint \
 	lib/softfloat \
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/Makefile.common	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -144,4 +144,5 @@
 LIBNIC_PREFIX = $(LIB_PREFIX)/nic
 LIBMINIX_PREFIX = $(LIB_PREFIX)/minix
+LIBCOMPRESS_PREFIX = $(LIB_PREFIX)/compress
 
 LIBSCSI_PREFIX = $(LIB_PREFIX)/scsi
Index: uspace/app/barber/Makefile
===================================================================
--- uspace/app/barber/Makefile	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
+++ uspace/app/barber/Makefile	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -0,0 +1,88 @@
+#
+# Copyright (c) 2014 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+
+LIBS = \
+	$(LIBGUI_PREFIX)/libgui.a \
+	$(LIBDRAW_PREFIX)/libdraw.a \
+	$(LIBCOMPRESS_PREFIX)/libcompress.a \
+	$(LIBSOFTREND_PREFIX)/libsoftrend.a \
+	$(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+
+EXTRA_CFLAGS += \
+	-I$(LIBGUI_PREFIX) \
+	-I$(LIBDRAW_PREFIX) \
+	-I$(LIBSOFTREND_PREFIX)
+
+BINARY = barber
+MATH = y
+
+SOURCES = \
+	barber.c \
+	images.c
+
+IMAGES = \
+	gfx/frame01.tga.gz \
+	gfx/frame02.tga.gz \
+	gfx/frame03.tga.gz \
+	gfx/frame04.tga.gz \
+	gfx/frame05.tga.gz \
+	gfx/frame06.tga.gz \
+	gfx/frame07.tga.gz \
+	gfx/frame08.tga.gz \
+	gfx/frame09.tga.gz \
+	gfx/frame10.tga.gz \
+	gfx/frame11.tga.gz \
+	gfx/frame12.tga.gz \
+	gfx/frame13.tga.gz \
+	gfx/frame14.tga.gz \
+	gfx/frame15.tga.gz \
+	gfx/frame16.tga.gz \
+	gfx/frame17.tga.gz \
+	gfx/frame18.tga.gz \
+	gfx/frame19.tga.gz \
+	gfx/frame20.tga.gz \
+	gfx/frame21.tga.gz \
+	gfx/frame22.tga.gz \
+	gfx/frame23.tga.gz \
+	gfx/frame24.tga.gz \
+	gfx/frame25.tga.gz \
+	gfx/frame26.tga.gz \
+	gfx/frame27.tga.gz \
+	gfx/frame28.tga.gz \
+	gfx/frame29.tga.gz \
+	gfx/frame30.tga.gz
+
+PRE_DEPEND = images.c images.h
+EXTRA_CLEAN = images.c images.h
+
+include $(USPACE_PREFIX)/Makefile.common
+
+images.c images.h: $(IMAGES)
+	$(ROOT_PATH)/tools/mkarray.py images COMPOSITOR_IMAGES $^
Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
+++ uspace/app/barber/barber.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -0,0 +1,339 @@
+/*
+ * Copyright (c) 2014 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup barber
+ * @{
+ */
+/** @file
+ */
+
+#include <unistd.h>
+#include <stdbool.h>
+#include <errno.h>
+#include <stdio.h>
+#include <malloc.h>
+#include <task.h>
+#include <loc.h>
+#include <stats.h>
+#include <fibril_synch.h>
+#include <io/pixel.h>
+#include <device/led_dev.h>
+#include <window.h>
+#include <canvas.h>
+#include <surface.h>
+#include <codec/tga.gz.h>
+#include "images.h"
+
+#define NAME  "barber"
+
+#define FRAMES  30
+
+#define MIN_FPS  1
+#define MAX_FPS  25
+
+#define MIN_LOAD  (LOAD_UNIT / 4)
+#define MAX_LOAD  (LOAD_UNIT / 3)
+
+#define FRAME_WIDTH   59
+#define FRAME_HEIGHT  192
+
+#define LED_PERIOD  1000000
+#define LED_COLORS  7
+
+typedef struct {
+	link_t link;
+	service_id_t svc_id;
+	async_sess_t *sess;
+} led_dev_t;
+
+static char *winreg = NULL;
+
+static fibril_timer_t *led_timer = NULL;
+static list_t led_devs;
+static unsigned int led_color = 0;
+
+static pixel_t led_colors[LED_COLORS] = {
+	PIXEL(0xff, 0xff, 0x00, 0x00),
+	PIXEL(0xff, 0x00, 0xff, 0x00),
+	PIXEL(0xff, 0x00, 0x00, 0xff),
+	PIXEL(0xff, 0xff, 0xff, 0x00),
+	PIXEL(0xff, 0xff, 0x00, 0xff),
+	PIXEL(0xff, 0x00, 0xff, 0xff),
+	PIXEL(0xff, 0xff, 0xff, 0xff)
+};
+
+static fibril_timer_t *frame_timer = NULL;
+static canvas_t *frame_canvas;
+static surface_t *frames[FRAMES];
+
+static unsigned int frame = 0;
+static unsigned int fps = MIN_FPS;
+
+static void led_timer_callback(void *);
+static void frame_timer_callback(void *);
+
+static bool decode_frames(void)
+{
+	frames[0] = decode_tga_gz((void *) frame01_tga_gz, frame01_tga_gz_size, 0);
+	frames[1] = decode_tga_gz((void *) frame02_tga_gz, frame02_tga_gz_size, 0);
+	frames[2] = decode_tga_gz((void *) frame03_tga_gz, frame03_tga_gz_size, 0);
+	frames[3] = decode_tga_gz((void *) frame04_tga_gz, frame04_tga_gz_size, 0);
+	frames[4] = decode_tga_gz((void *) frame05_tga_gz, frame05_tga_gz_size, 0);
+	frames[5] = decode_tga_gz((void *) frame06_tga_gz, frame06_tga_gz_size, 0);
+	frames[6] = decode_tga_gz((void *) frame07_tga_gz, frame07_tga_gz_size, 0);
+	frames[7] = decode_tga_gz((void *) frame08_tga_gz, frame08_tga_gz_size, 0);
+	frames[8] = decode_tga_gz((void *) frame09_tga_gz, frame09_tga_gz_size, 0);
+	frames[9] = decode_tga_gz((void *) frame10_tga_gz, frame10_tga_gz_size, 0);
+	frames[10] = decode_tga_gz((void *) frame11_tga_gz, frame11_tga_gz_size, 0);
+	frames[11] = decode_tga_gz((void *) frame12_tga_gz, frame12_tga_gz_size, 0);
+	frames[12] = decode_tga_gz((void *) frame13_tga_gz, frame13_tga_gz_size, 0);
+	frames[13] = decode_tga_gz((void *) frame14_tga_gz, frame14_tga_gz_size, 0);
+	frames[14] = decode_tga_gz((void *) frame15_tga_gz, frame15_tga_gz_size, 0);
+	frames[15] = decode_tga_gz((void *) frame16_tga_gz, frame16_tga_gz_size, 0);
+	frames[16] = decode_tga_gz((void *) frame17_tga_gz, frame17_tga_gz_size, 0);
+	frames[17] = decode_tga_gz((void *) frame18_tga_gz, frame18_tga_gz_size, 0);
+	frames[18] = decode_tga_gz((void *) frame19_tga_gz, frame19_tga_gz_size, 0);
+	frames[19] = decode_tga_gz((void *) frame20_tga_gz, frame20_tga_gz_size, 0);
+	frames[20] = decode_tga_gz((void *) frame21_tga_gz, frame21_tga_gz_size, 0);
+	frames[21] = decode_tga_gz((void *) frame22_tga_gz, frame22_tga_gz_size, 0);
+	frames[22] = decode_tga_gz((void *) frame23_tga_gz, frame23_tga_gz_size, 0);
+	frames[23] = decode_tga_gz((void *) frame24_tga_gz, frame24_tga_gz_size, 0);
+	frames[24] = decode_tga_gz((void *) frame25_tga_gz, frame25_tga_gz_size, 0);
+	frames[25] = decode_tga_gz((void *) frame26_tga_gz, frame26_tga_gz_size, 0);
+	frames[26] = decode_tga_gz((void *) frame27_tga_gz, frame27_tga_gz_size, 0);
+	frames[27] = decode_tga_gz((void *) frame28_tga_gz, frame28_tga_gz_size, 0);
+	frames[28] = decode_tga_gz((void *) frame29_tga_gz, frame29_tga_gz_size, 0);
+	frames[29] = decode_tga_gz((void *) frame30_tga_gz, frame30_tga_gz_size, 0);
+	
+	for (unsigned int frame = 0; frame < FRAMES; frame++) {
+		if (frames[frame] == NULL) {
+			printf("Unable to decode frame %u.\n", frame);
+			return false;
+		}
+	}
+	
+	return true;
+}
+
+static void plan_led_timer(void)
+{
+	fibril_timer_set(led_timer, LED_PERIOD, led_timer_callback, NULL);
+}
+
+static load_t get_load(void)
+{
+	size_t count;
+	load_t *load = stats_get_load(&count);
+	load_t load_val;
+	
+	if ((load != NULL) && (count > 0)) {
+		load_val = load[0];
+		free(load);
+	} else
+		load_val = 0;
+	
+	return load_val;
+}
+
+static void plan_frame_timer(suseconds_t render_time)
+{
+	/*
+	 * Crank up the FPS unless we lack
+	 * behind with the rendering and
+	 * unless the load is not above
+	 * a lower threshold.
+	 */
+	
+	suseconds_t delta = 1000000 / fps;
+	load_t load = get_load();
+	
+	if ((delta >= render_time) && (load < MIN_LOAD))
+		fps++;
+	
+	if (fps > MAX_FPS)
+		fps = MAX_FPS;
+	
+	/*
+	 * If we lack behind then immediately
+	 * go to the lowest FPS.
+	 */
+	
+	if (delta < render_time)
+		fps = MIN_FPS;
+	
+	/*
+	 * Crank down the FPS if the current
+	 * load is above an upper threshold.
+	 */
+	
+	if (load > MAX_LOAD)
+		fps--;
+	
+	if (fps < MIN_FPS)
+		fps = MIN_FPS;
+	
+	delta = 1000000 / fps;
+	
+	fibril_timer_set(frame_timer, delta, frame_timer_callback, NULL);
+}
+
+static void led_timer_callback(void *data)
+{
+	pixel_t next_led_color = led_colors[led_color];
+	
+	led_color++;
+	if (led_color >= LED_COLORS)
+		led_color = 0;
+	
+	list_foreach(led_devs, link, led_dev_t, dev) {
+		if (dev->sess)
+			led_dev_color_set(dev->sess, next_led_color);
+	}
+	
+	plan_led_timer();
+}
+
+static void frame_timer_callback(void *data)
+{
+	struct timeval prev;
+	getuptime(&prev);
+	
+	frame++;
+	if (frame >= FRAMES)
+		frame = 0;
+	
+	update_canvas(frame_canvas, frames[frame]);
+	
+	struct timeval cur;
+	getuptime(&cur);
+	
+	plan_frame_timer(tv_sub(&cur, &prev));
+}
+
+static void loc_callback(void)
+{
+	category_id_t led_cat;
+	int rc = loc_category_get_id("led", &led_cat, IPC_FLAG_BLOCKING);
+	if (rc != EOK)
+		return;
+	
+	service_id_t *svcs;
+	size_t count;
+	rc = loc_category_get_svcs(led_cat, &svcs, &count);
+	if (rc != EOK)
+		return;
+	
+	for (size_t i = 0; i < count; i++) {
+		bool known = false;
+		
+		/* Determine whether we already know this device. */
+		list_foreach(led_devs, link, led_dev_t, dev) {
+			if (dev->svc_id == svcs[i]) {
+				known = true;
+				break;
+			}
+		}
+		
+		if (!known) {
+			led_dev_t *dev = (led_dev_t *) calloc(1, sizeof(led_dev_t));
+			if (!dev)
+				continue;
+			
+			link_initialize(&dev->link);
+			dev->svc_id = svcs[i];
+			dev->sess = loc_service_connect(EXCHANGE_SERIALIZE, svcs[i], 0);
+			
+			list_append(&dev->link, &led_devs);
+		}
+	}
+	
+	// FIXME: Handle LED device removal
+	
+	free(svcs);
+}
+
+int main(int argc, char *argv[])
+{
+	if (argc < 2) {
+		printf("Compositor server not specified.\n");
+		return 1;
+	}
+	
+	list_initialize(&led_devs);
+	int rc = loc_register_cat_change_cb(loc_callback);
+	if (rc != EOK) {
+		printf("Unable to register callback for device discovery.\n");
+		return 1;
+	}
+	
+	led_timer = fibril_timer_create(NULL);
+	if (!led_timer) {
+		printf("Unable to create LED timer.\n");
+		return 1;
+	}
+	
+	frame_timer = fibril_timer_create(NULL);
+	if (!frame_timer) {
+		printf("Unable to create frame timer.\n");
+		return 1;
+	}
+	
+	if (!decode_frames())
+		return 1;
+	
+	winreg = argv[1];
+	window_t *main_window = window_open(argv[1], true, true, "barber");
+	if (!main_window) {
+		printf("Cannot open main window.\n");
+		return 1;
+	}
+	
+	frame_canvas = create_canvas(window_root(main_window),
+	    FRAME_WIDTH, FRAME_HEIGHT, frames[frame]);
+	
+	if (!frame_canvas) {
+		window_close(main_window);
+		printf("Cannot create widgets.\n");
+		return 1;
+	}
+	
+	window_resize(main_window, 0, 0, FRAME_WIDTH + 8, FRAME_HEIGHT + 28,
+	    WINDOW_PLACEMENT_RIGHT | WINDOW_PLACEMENT_BOTTOM);
+	window_exec(main_window);
+	
+	plan_led_timer();
+	plan_frame_timer(0);
+	
+	task_retval(0);
+	async_manager();
+	
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/app/bnchmark/bnchmark.c
===================================================================
--- uspace/app/bnchmark/bnchmark.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/bnchmark/bnchmark.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -62,23 +62,14 @@
 {
 	struct timeval start_time;
-	int rc;
-	rc = gettimeofday(&start_time, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "gettimeofday failed\n");
-		return rc;
-	}
-	
-	rc = fn(data);
+	gettimeofday(&start_time, NULL);
+	
+	int rc = fn(data);
 	if (rc != EOK) {
 		fprintf(stderr, "measured function failed\n");
 		return rc;
 	}
-
+	
 	struct timeval final_time;
-	rc = gettimeofday(&final_time, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "gettimeofday failed\n");
-		return rc;
-	}
+	gettimeofday(&final_time, NULL);
 	
 	/* Calculate time difference in milliseconds */
@@ -92,8 +83,7 @@
 	char *path = (char *) data;
 	char *buf = malloc(BUFSIZE);
-
-	if (buf == NULL) {
+	
+	if (buf == NULL)
 		return ENOMEM;
-	}
 	
 	FILE *file = fopen(path, "r");
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/init/init.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -355,4 +355,5 @@
 	int rc = compositor(HID_INPUT, HID_COMPOSITOR_SERVER);
 	if (rc == EOK) {
+		gui_start("/app/barber", HID_COMPOSITOR_SERVER);
 		gui_start("/app/vlaunch", HID_COMPOSITOR_SERVER);
 		gui_start("/app/vterm", HID_COMPOSITOR_SERVER);
Index: uspace/app/modplay/modplay.c
===================================================================
--- uspace/app/modplay/modplay.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/modplay/modplay.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -40,5 +40,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <protracker.h>
 #include <trackmod.h>
 
@@ -88,5 +87,5 @@
 	con = console_init(stdin, stdout);
 
-	rc = trackmod_protracker_load(argv[1], &mod);
+	rc = trackmod_module_load(argv[1], &mod);
 	if (rc != EOK) {
 		printf("Error loading %s.\n", argv[1]);
Index: uspace/app/nettest1/nettest1.c
===================================================================
--- uspace/app/nettest1/nettest1.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/nettest1/nettest1.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -402,9 +402,5 @@
 	
 	struct timeval time_before;
-	rc = gettimeofday(&time_before, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "Get time of day error %d\n", rc);
-		return rc;
-	}
+	gettimeofday(&time_before, NULL);
 	
 	nettest1_test(socket_ids,       1,        1);
@@ -414,9 +410,5 @@
 	
 	struct timeval time_after;
-	rc = gettimeofday(&time_after, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "Get time of day error %d\n", rc);
-		return rc;
-	}
+	gettimeofday(&time_after, NULL);
 	
 	printf("Tested in %ld microseconds\n", tv_sub(&time_after,
Index: uspace/app/nettest2/nettest2.c
===================================================================
--- uspace/app/nettest2/nettest2.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/nettest2/nettest2.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -356,9 +356,5 @@
 	
 	struct timeval time_before;
-	rc = gettimeofday(&time_before, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "Get time of day error %d\n", rc);
-		return rc;
-	}
+	gettimeofday(&time_before, NULL);
 	
 	rc = sockets_sendto_recvfrom(verbose, socket_ids, sockets, address,
@@ -368,9 +364,5 @@
 	
 	struct timeval time_after;
-	rc = gettimeofday(&time_after, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "Get time of day error %d\n", rc);
-		return rc;
-	}
+	gettimeofday(&time_after, NULL);
 	
 	if (verbose)
@@ -380,9 +372,5 @@
 	    tv_sub(&time_after, &time_before));
 	
-	rc = gettimeofday(&time_before, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "Get time of day error %d\n", rc);
-		return rc;
-	}
+	gettimeofday(&time_before, NULL);
 	
 	rc = sockets_sendto(verbose, socket_ids, sockets, address, addrlen,
@@ -396,9 +384,5 @@
 		return rc;
 	
-	rc = gettimeofday(&time_after, NULL);
-	if (rc != EOK) {
-		fprintf(stderr, "Get time of day error %d\n", rc);
-		return rc;
-	}
+	gettimeofday(&time_after, NULL);
 	
 	if (verbose)
Index: uspace/app/stats/stats.c
===================================================================
--- uspace/app/stats/stats.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/stats/stats.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -191,9 +191,10 @@
 static void print_uptime(void)
 {
-	sysarg_t uptime = stats_get_uptime();
-	printf("%s: Up %" PRIun " days, %" PRIun " hours, "
-	    "%" PRIun " minutes, %" PRIun " seconds\n", NAME,
-	    uptime / DAY, (uptime % DAY) / HOUR,
-	    (uptime % HOUR) / MINUTE, uptime % MINUTE);
+	struct timeval uptime;
+	getuptime(&uptime);
+	
+	printf("%s: Up %ld days, %ld hours, %ld minutes, %ld seconds\n",
+	    NAME, uptime.tv_sec / DAY, (uptime.tv_sec % DAY) / HOUR,
+	    (uptime.tv_sec % HOUR) / MINUTE, uptime.tv_sec % MINUTE);
 }
 
Index: uspace/app/tester/ipc/ping_pong.c
===================================================================
--- uspace/app/tester/ipc/ping_pong.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/tester/ipc/ping_pong.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -43,16 +43,10 @@
 	
 	struct timeval start;
-	if (gettimeofday(&start, NULL) != 0) {
-		TPRINTF("\n");
-		return "Failed getting the time";
-	}
+	gettimeofday(&start, NULL);
 	
 	uint64_t count = 0;
 	while (true) {
 		struct timeval now;
-		if (gettimeofday(&now, NULL) != 0) {
-			TPRINTF("\n");
-			return "Failed getting the time";
-		}
+		gettimeofday(&now, NULL);
 		
 		if (tv_sub(&now, &start) >= DURATION_SECS * 1000000L)
Index: uspace/app/tester/ipc/starve.c
===================================================================
--- uspace/app/tester/ipc/starve.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/tester/ipc/starve.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -40,13 +40,9 @@
 	const char *err = NULL;
 	console_ctrl_t *console = console_init(stdin, stdout);
-	if (console == NULL) {
+	if (console == NULL)
 		return "Failed to init connection with console.";
-	}
 	
 	struct timeval start;
-	if (gettimeofday(&start, NULL) != 0) {
-		err = "Failed getting the time";
-		goto leave;
-	}
+	gettimeofday(&start, NULL);
 	
 	TPRINTF("Intensive computation shall be imagined (for %ds)...\n", DURATION_SECS);
@@ -54,8 +50,5 @@
 	while (true) {
 		struct timeval now;
-		if (gettimeofday(&now, NULL) != 0) {
-			err = "Failed getting the time";
-			goto leave;
-		}
+		gettimeofday(&now, NULL);
 		
 		if (tv_sub(&now, &start) >= DURATION_SECS * 1000000L)
@@ -70,15 +63,14 @@
 		}
 	}
-
+	
 	// FIXME - unless a key was pressed, the answer leaked as no one
 	// will wait for it.
 	// We cannot use async_forget() directly, though. Something like
 	// console_forget_pending_kbd_event() shall come here.
-
+	
 	TPRINTF("Terminating...\n");
-
-leave:
+	
 	console_done(console);
-
+	
 	return err;
 }
Index: uspace/app/testread/testread.c
===================================================================
--- uspace/app/testread/testread.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/testread/testread.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -123,12 +123,5 @@
 	struct timeval prev_time;
 	struct timeval start_time;
-	int rc;
-	rc = gettimeofday(&start_time, NULL);
-	if (rc != EOK) {
-		printf("gettimeofday failed\n");
-		fclose(file);
-		free(buf);
-		return 1;
-	}
+	gettimeofday(&start_time, NULL);
 	prev_time = start_time;
 	
@@ -155,11 +148,6 @@
 		if (progress && offset >= next_mark) {
 			struct timeval cur_time;
-			rc = gettimeofday(&cur_time, NULL);
-			if (rc != EOK) {
-				printf("gettimeofday failed\n");
-				fclose(file);
-				free(buf);
-				return 1;
-			}
+			gettimeofday(&cur_time, NULL);
+			
 			uint32_t last_run = cur_time.tv_sec - prev_time.tv_sec;
 			uint32_t total_time = cur_time.tv_sec - start_time.tv_sec;
@@ -178,11 +166,5 @@
 	
 	struct timeval final_time;
-	rc = gettimeofday(&final_time, NULL);
-	if (rc != EOK) {
-		printf("gettimeofday failed\n");
-		fclose(file);
-		free(buf);
-		return 1;
-	}
+	gettimeofday(&final_time, NULL);
 	
 	uint32_t total_run_time = final_time.tv_sec - start_time.tv_sec;
Index: uspace/app/top/top.c
===================================================================
--- uspace/app/top/top.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/top/top.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -156,6 +156,5 @@
 	/* Get current time */
 	struct timeval time;
-	if (gettimeofday(&time, NULL) != EOK)
-		return "Cannot get time of day";
+	gettimeofday(&time, NULL);
 	
 	target->hours = (time.tv_sec % DAY) / HOUR;
@@ -164,9 +163,11 @@
 	
 	/* Get uptime */
-	sysarg_t uptime = stats_get_uptime();
-	target->udays = uptime / DAY;
-	target->uhours = (uptime % DAY) / HOUR;
-	target->uminutes = (uptime % HOUR) / MINUTE;
-	target->useconds = uptime % MINUTE;
+	struct timeval uptime;
+	getuptime(&uptime);
+	
+	target->udays = uptime.tv_sec / DAY;
+	target->uhours = (uptime.tv_sec % DAY) / HOUR;
+	target->uminutes = (uptime.tv_sec % HOUR) / MINUTE;
+	target->useconds = uptime.tv_sec % MINUTE;
 	
 	/* Get load */
Index: uspace/app/vlaunch/vlaunch.c
===================================================================
--- uspace/app/vlaunch/vlaunch.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/app/vlaunch/vlaunch.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -37,12 +37,6 @@
 #include <stdio.h>
 #include <malloc.h>
-#include <io/pixel.h>
 #include <task.h>
-#include <str.h>
 #include <str_error.h>
-#include <loc.h>
-#include <fibril_synch.h>
-#include <io/pixel.h>
-#include <device/led_dev.h>
 
 #include <window.h>
@@ -64,28 +58,5 @@
 #define LOGO_HEIGHT  66
 
-#define PERIOD  1000000
-#define COLORS  7
-
 static char *winreg = NULL;
-static fibril_timer_t *timer = NULL;
-static list_t led_devs;
-
-static pixel_t colors[COLORS] = {
-	PIXEL(0xff, 0xff, 0x00, 0x00),
-	PIXEL(0xff, 0x00, 0xff, 0x00),
-	PIXEL(0xff, 0x00, 0x00, 0xff),
-	PIXEL(0xff, 0xff, 0xff, 0x00),
-	PIXEL(0xff, 0xff, 0x00, 0xff),
-	PIXEL(0xff, 0x00, 0xff, 0xff),
-	PIXEL(0xff, 0xff, 0xff, 0xff)
-};
-
-static unsigned int color = 0;
-
-typedef struct {
-	link_t link;
-	service_id_t svc_id;
-	async_sess_t *sess;
-} led_dev_t;
 
 static int app_launch(const char *app)
@@ -129,79 +100,8 @@
 }
 
-static void timer_callback(void *data)
-{
-	pixel_t next_color = colors[color];
-	
-	color++;
-	if (color >= COLORS)
-		color = 0;
-	
-	list_foreach(led_devs, link, led_dev_t, dev) {
-		if (dev->sess)
-			led_dev_color_set(dev->sess, next_color);
-	}
-	
-	fibril_timer_set(timer, PERIOD, timer_callback, NULL);
-}
-
-static void loc_callback(void)
-{
-	category_id_t led_cat;
-	int rc = loc_category_get_id("led", &led_cat, IPC_FLAG_BLOCKING);
-	if (rc != EOK)
-		return;
-	
-	service_id_t *svcs;
-	size_t count;
-	rc = loc_category_get_svcs(led_cat, &svcs, &count);
-	if (rc != EOK)
-		return;
-	
-	for (size_t i = 0; i < count; i++) {
-		bool known = false;
-		
-		/* Determine whether we already know this device. */
-		list_foreach(led_devs, link, led_dev_t, dev) {
-			if (dev->svc_id == svcs[i]) {
-				known = true;
-				break;
-			}
-		}
-		
-		if (!known) {
-			led_dev_t *dev = (led_dev_t *) calloc(1, sizeof(led_dev_t));
-			if (!dev)
-				continue;
-			
-			link_initialize(&dev->link);
-			dev->svc_id = svcs[i];
-			dev->sess = loc_service_connect(EXCHANGE_SERIALIZE, svcs[i], 0);
-			
-			list_append(&dev->link, &led_devs);
-		}
-	}
-	
-	// FIXME: Handle LED device removal
-	
-	free(svcs);
-}
-
 int main(int argc, char *argv[])
 {
 	if (argc < 2) {
 		printf("Compositor server not specified.\n");
-		return 1;
-	}
-	
-	list_initialize(&led_devs);
-	int rc = loc_register_cat_change_cb(loc_callback);
-	if (rc != EOK) {
-		printf("Unable to register callback for device discovery.\n");
-		return 1;
-	}
-	
-	timer = fibril_timer_create(NULL);
-	if (!timer) {
-		printf("Unable to create timer.\n");
 		return 1;
 	}
@@ -262,6 +162,4 @@
 	window_exec(main_window);
 	
-	fibril_timer_set(timer, PERIOD, timer_callback, NULL);
-	
 	task_retval(0);
 	async_manager();
Index: uspace/lib/c/generic/stats.c
===================================================================
--- uspace/lib/c/generic/stats.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/lib/c/generic/stats.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -291,18 +291,4 @@
 }
 
-/** Get system uptime
- *
- * @return System uptime (in seconds).
- *
- */
-sysarg_t stats_get_uptime(void)
-{
-	sysarg_t uptime;
-	if (sysinfo_get_value("system.uptime", &uptime) != EOK)
-		uptime = 0;
-	
-	return uptime;
-}
-
 /** Print load fixed-point value
  *
@@ -316,16 +302,13 @@
 void stats_print_load_fragment(load_t upper, unsigned int dec_length)
 {
-	/* Magic value from BSD */
-	load_t lower = 65536;
-	
 	/* Print the whole part */
-	printf("%u.", upper / lower);
-	
-	load_t rest = (upper % lower) * 10;
+	printf("%u.", upper / LOAD_UNIT);
+	
+	load_t rest = (upper % LOAD_UNIT) * 10;
 	
 	unsigned int i;
 	for (i = 0; i < dec_length; i++) {
-		printf("%u", rest / lower);
-		rest = (rest % lower) * 10;
+		printf("%u", rest / LOAD_UNIT);
+		rest = (rest % LOAD_UNIT) * 10;
 	}
 }
